<%@ language="VBScript" %>
<html>
<head>
<title>EditLive! for XML - Visual Designer</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link type="text/css" rel="stylesheet" href="stylesheet.css">
</head>
<body>
    <h1>Visual Designer</h1>
    <p>Edit the form and its data structure in the Visual Designer and submit to EditLive! for XML.</p>

    <%
    'This function reads a given file from the given forms subdirectory
    Function getFileContents(directory, fileName)
        Const ForReading = 1
        Dim fso, f, path, content
        'Construct the path to the file on the server
        path = Server.MapPath("../../../forms/" & directory) & "\" & fileName
        Set fso = Server.CreateObject("Scripting.FileSystemObject")
        Set f = fso.OpenTextFile(path, ForReading)
        'Read the file content
        content = f.ReadAll
        'Close and release the file
        f.Close
        Set f=Nothing
        Set fso=Nothing
        'return the file content
        getFileContents = content
    End Function
    %>

	<%
		Dim xsd
		Dim views(6)
		Dim viewNames(6)
		Dim viewCount
        Dim createNew

        createNew = false

		Dim example
		If Request.QueryString("example").Count > 0 Then
			example = Request.QueryString("example").Item(1)
		End If

        'This series of if statements read the XSD and XSLs for the
        'requested form into variables for outputting later.

        'The XSD is read into the xsd variable

        'Each XSL is assigned a name in the viewNames array and
        'the content of the XSL is placed in the views array

		If example = "Contact Details" Then
            'Read the files for the Contact Details form
			xsd = getFileContents("contactdetails", "contactdetails.xsd")

			viewNames(1) = "Company"
			views(1) = getFileContents("contactdetails", "company.xsl")
			viewNames(2) = "Contact"
			views(2) = getFileContents("contactdetails", "contact.xsl")
			viewNames(3) = "Activity"
			views(3) = getFileContents("contactdetails", "activity.xsl")
			viewCount = 3

		ElseIf example = "Expenses" Then
            'Read the files for the Expenses form
			xsd = getFileContents("expenses", "expenses.xsd")

			viewNames(1) = "Expenses"
			views(1) = getFileContents("expenses", "expenses.xsl")
			viewCount = 1

		ElseIf example = "Invoice" Then
            'Read the files for the Invoice form
			xsd = getFileContents("invoice", "invoice.xsd")

			viewCount = 2
			viewNames(1) = "Invoice"
			views(1) = getFileContents("invoice", "invoice.xsl")

			viewNames(2) = "Packing"
			views(2) = getFileContents("invoice", "packing.xsl")

		ElseIf example = "Leave Application" Then
            'Read the files for the Leave Application form
			xsd = getFileContents("leaveapplication", "leaveapplication.xsd")

			viewCount = 1
			viewNames(1) = "Leave Application"
			views(1) = getFileContents("leaveapplication", "leave.xsl")

		ElseIf example = "Partner Application" Then
            'Read the files for the Partner Application form
			xsd = getFileContents("partnerapplication", "partnerapplication.xsd")

			viewCount = 6
			viewNames(1) = "Default"
			views(1) = getFileContents("partnerapplication", "default.xsl")
			viewNames(2) = "Company"
			views(2) = getFileContents("partnerapplication", "company.xsl")
			viewNames(3) = "Contacts"
			views(3) = getFileContents("partnerapplication", "contacts.xsl")
			viewNames(4) = "Markets"
			views(4) = getFileContents("partnerapplication", "markets.xsl")
			viewNames(5) = "Products"
			views(5) = getFileContents("partnerapplication", "products.xsl")
			viewNames(6) = "Sales"
			views(6) = getFileContents("partnerapplication", "sales.xsl")

		ElseIf example = "Quotation" Then
            'Read the files for the Quotation form
			xsd = getFileContents("quotation", "quotation.xsd")

			viewCount = 1
			viewNames(1) = "Quote"
			views(1) = getFileContents("quotation", "quote.xsl")

		ElseIf example = "Sales Report" Then
            'Read the files for the Sales Report form
			xsd = getFileContents("salesreport", "salesreport.xsd")

			viewCount = 1
			viewNames(1) = "Sales"
			views(1) = getFileContents("salesreport", "sales.xsl")

		ElseIf example = "Support Issue" Then
            'Read the files for the Support Issue form
			xsd = getFileContents("supportissue", "supportissue.xsd")

	    	viewCount = 2
			viewNames(1) = "Issue"
			views(1) = getFileContents("supportissue", "issue.xsl")
			viewNames(2) = "Comments"
			views(2) = getFileContents("supportissue", "comments.xsl")

		ElseIf example = "Vehicle Booking" Then
            'Read the files for the Vehicle Booking form
			xsd = getFileContents("vehiclebooking", "vehiclebooking.xsd")

			viewCount = 1
			viewNames(1) = "Booking"
			views(1) = getFileContents("vehiclebooking", "booking.xsl")
        ElseIf example = "Create New Form" Then
            'Set the create new form flag
            createNew = true
		End If
	%>

	<form action="elx.asp" method="POST" name="form1">
		<script src="../../../redistributables/editlivexml/visualdesigner.js" language="JavaScript"></script>
		<script language="JavaScript">
		<!--
		   var designerInstance;
		   // Create a new Visual Designer instance with the name
		   // "VDApplet1", a height of 600 pixels and a width of 1000 pixels.
		   designerInstance = new VisualDesigner("VDApplet1", 1000, 600);
		   // This sets a relative path to the directory where
		   // the EditLive! for XML redistributables can be
		   // found e.g. designer.jar
		   designerInstance.setDownloadDirectory("../../../redistributables/editlivexml");
           // Set the output character set to ASCII to ensure that character
           // encoding is correct
           designerInstance.setOutputCharset("ASCII");
           // This sets a relative or absolute path to the XML
		   // configuration file to use.
		   designerInstance.setConfigurationFile("designerconfig.xml");
           <%
           If Not createNew Then
           %>
		   // This sets the schema (XSD) to be edited with this instance of
		   // the Visual Designer
		   designerInstance.setXSDAsText("<%= Server.URLEncode(xsd) %>");
           <%
           End If
           %>
		   // This sets the views to be edited with this instance of the
		   // Visual Designer.

		   <%
            If Not createNew Then
                Dim i
                For i = 1 to viewCount
                    Response.Write "designerInstance.addViewAsText(""" & Server.URLEncode(viewNames(i)) & """, """ & Server.URLEncode(views(i)) & """);"
                Next
             End If
		   %>
		   // .show is the final call and instructs the JavaScript
		   // library (visualdesigner.js) to insert a new EditLive! for XML
		   // at the this location.
		   designerInstance.show();

		-->
		</script>

        <p><input type="submit" value="View in ELX"> <input type="button" value="Form Type Selection" onclick="location.href='default.asp';"></p>
	</form>
</body>
</html>