<%@page import="java.util.*"%>
<%@page import="java.io.*"%>
<%@page import="java.net.*"%>
<html>
<head>
<title>EditLive! for XML - Visual Designer</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link type="text/css" rel="stylesheet" href="stylesheet.css"/>
</head>
<body>
	<h1>Visual Designer</h1>
    <p>Edit the form and its data structure in the Visual Designer and submit to EditLive! for XML.</p>

	<%!
        /*
            This method retrieves the content of a given file from a given subdirectory
        */
		public String getFileContents(String directory, String fileName) {
			try {
                //Construct the path to the file on the server.  
                //Note that this path is resolved relative to this application's
                //root directory
				String path = getServletContext().getRealPath("forms" + File.separator + directory + File.separator + fileName);
				BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(path)));
				StringBuffer buf = new StringBuffer();
                //Read the file into a variable one line at a time
				String line = in.readLine();
				while (line != null) {
					buf.append(line);
					buf.append("\n");
					line = in.readLine();
				}
				
				in.close();
                //Return the content of the file
				return buf.toString();
			} catch (Exception e) {
				e.printStackTrace();
				return "";
			}
		}
	%>
	
	<%
		
		String xsd = "";
		List views = new ArrayList();
		List viewNames = new ArrayList();
        boolean createNew = false;

		String example = request.getParameter("example");
        
        /*
        This series of if statements read the XSD and XSLs for the 
        requested form into variables for outputting later.
        
        The XSD is read into the xsd variable
        
        Each XSL is assigned a name in the viewNames list and 
        the content of the XSL is placed in the views list
        */

		if (example.equals("Contact Details")) {
            //Read the files for the Contact Details form
			xsd = getFileContents("contactdetails", "contactdetails.xsd");

			viewNames.add("Company");
			views.add(getFileContents("contactdetails", "company.xsl"));
			viewNames.add("Contact");
			views.add(getFileContents("contactdetails", "contact.xsl"));
			viewNames.add("Activity");
			views.add(getFileContents("contactdetails", "activity.xsl"));

		} else if (example.equals("Expenses")) {
            //Read the files for the Expenses form
			xsd = getFileContents("expenses", "expenses.xsd");

			viewNames.add("Expenses");
			views.add(getFileContents("expenses", "expenses.xsl"));

		} else if (example.equals("Invoice")) {
            //Read the files for the Invoice form
			xsd = getFileContents("invoice", "invoice.xsd");

			viewNames.add("Invoice");
			views.add(getFileContents("invoice", "invoice.xsl"));

			viewNames.add("Packing");
			views.add(getFileContents("invoice", "packing.xsl"));

		} else if (example.equals("Leave Application")) {
            //Read the files for the Leave Application form
			xsd = getFileContents("leaveapplication", "leaveapplication.xsd");

			viewNames.add("Leave Application");
			views.add(getFileContents("leaveapplication", "leave.xsl"));

		} else if (example.equals("Partner Application")) {
            //Read the files for the Partner Application form
			xsd = getFileContents("partnerapplication", "partnerapplication.xsd");

			viewNames.add("Default");
			views.add(getFileContents("partnerapplication", "default.xsl"));
			viewNames.add("Company");
			views.add(getFileContents("partnerapplication", "company.xsl"));
			viewNames.add("Contacts");
			views.add(getFileContents("partnerapplication", "contacts.xsl"));
			viewNames.add("Markets");
			views.add(getFileContents("partnerapplication", "markets.xsl"));
			viewNames.add("Products");
			views.add(getFileContents("partnerapplication", "products.xsl"));
			viewNames.add("Sales");
			views.add(getFileContents("partnerapplication", "sales.xsl"));

		} else if (example.equals("Quotation")) {
            //Read the files for the Quotation form
			xsd = getFileContents("quotation", "quotation.xsd");

			viewNames.add("Quote");
			views.add(getFileContents("quotation", "quote.xsl"));

		} else if (example.equals("Sales Report")) {
            //Read the files for the Sales Report form
			xsd = getFileContents("salesreport", "salesreport.xsd");

			viewNames.add("Sales");
			views.add(getFileContents("salesreport", "sales.xsl"));

		} else if (example.equals("Support Issue")) {
            //Read the files for the Support Issue form
			xsd = getFileContents("supportissue", "supportissue.xsd");

			viewNames.add("Issue");
			views.add(getFileContents("supportissue", "issue.xsl"));
			viewNames.add("Comments");
			views.add(getFileContents("supportissue", "comments.xsl"));

		} else if (example.equals("Vehicle Booking")) {
            //Read the files for the Vehicle Booking form
			xsd = getFileContents("vehiclebooking", "vehiclebooking.xsd");

			viewNames.add("Booking");
			views.add(getFileContents("vehiclebooking", "booking.xsl"));
		} else if (example.equals("Create New Form")) {
            //Set the create a new form flag
            createNew = true;            
        }
	%>

	<form action="elx.jsp" method="POST" name="form1">
		<script src="../../../redistributables/editlivexml/visualdesigner.js" language="JavaScript"></script>
		<script language="JavaScript">
		<!--
		   var designerInstance;
		   // Create a new Visual Designer instance with the name
		   // "VDApplet1", a height of 700 pixels and a width of 800 pixels.
		   designerInstance = new VisualDesigner("VDApplet1", 1000, 600);
		   // This sets a relative path to the directory where
		   // the EditLive! for XML redistributables can be
		   // found e.g. designer.jar
           designerInstance.setDebugLevel("debug");
		   designerInstance.setDownloadDirectory("../../../redistributables/editlivexml");
           // Set the output character set to ASCII to ensure that character 
           // encoding is correct
           designerInstance.setOutputCharset("ASCII");
		   // This sets a relative or absolute path to the XML
		   // configuration file to use.
		   designerInstance.setConfigurationFile("designerconfig.xml");
           <%
           if (!createNew){
           %>
		   // This sets the schema (XSD) to be edited with this instance of
		   // the Visual Designer
		   designerInstance.setXSDAsText("<% out.print(URLEncoder.encode(xsd)); %>");
           <%
           }
           %>
		   // This sets the views to be edited with this instance of the
		   // Visual Designer.
		   <%
            if(!createNew){
                Iterator namesIter = viewNames.iterator();
                Iterator viewsIter = views.iterator();
                while (namesIter.hasNext() && viewsIter.hasNext()) {
                    out.println("designerInstance.addViewAsText(\"" + URLEncoder.encode((String)namesIter.next()) + "\", \"" + URLEncoder.encode((String)viewsIter.next()) + "\");");
                }
           }
		   %>
		   
		   // .show is the final call and instructs the JavaScript
		   // library (visualdesigner.js) to insert a new EditLive! for XML
		   // at the this location.
		   designerInstance.show();

		-->
		</script>

		<p><input type="submit" value="View in ELX"> <input type="button" value="Form Type Selection" onclick="location.href='default.jsp';"></p>
	</form>
</body>
</html>